/*================================================================
  Xsnake.h -> Fichero de cabecera para XSnake.
  (c) 1999 Santiago Romero Iglesias y Antonio Fernandez Fandos
 ================================================================*/

#define VELOCIDAD    70000
#define INCREMENTO      10
#define MAX_COMIDA       5
#define xmin             0
#define xmax            79
#define ymin             0
#define ymax            39

#define true             1
#define false            0
#define boolean       char

#define VACIO            0
#define SERPIENTE        1
#define PARED            2
#define COMIDA1          3
#define COMIDA2          4
#define COMIDA3          5
#define COMIDA4          6

#define ANCHURA_BLOQUE   7
#define ALTURA_BLOQUE    9

#define DIR_IZQ          1
#define DIR_DER          2
#define DIR_ARR          3
#define DIR_ABJO         4

/* Codigos de teclas, verlos todos en el fichero
   /usr/X11R6/lib/X11/xkb/keycodes/xfree86     */
#define ESC_KEY          9
#define ARRIBA          98
#define ABAJO          104
#define IZQUIERDA      100
#define DERECHA        102


/*--- Variables globales utilizadas ---------------------*/
Pixmap sprites[4];
long amarillo, verde, negro, tiempo=0, segundos=0;
char done = 0, tecla = 0;
char comida;

char pantalla[xmax+1][ymax+1], cola[xmax+1][ymax+1];

struct serpiente
{
  int cabserx, cabsery, colaserx, colasery, espera;
  char izquierda, derecha, arriba, abajo;
  int puntos;

};

/* estructuras para el cronometrado de tiempo */
struct timeval start, end;
long time_dif;

/*--- Declaraciones de funciones ------------------------*/
void InicializaMatrices( void );
void InicializaSerpiente( struct serpiente * );
void DibujaTablero( Display *, Pixmap, Drawable, GC );
void LeerMovimiento( char, struct serpiente * );
void Movimiento( Display *, Drawable, Drawable, GC,
                 struct serpiente * );
void DibujaSerpiente( Display *, Pixmap, Window, GC,
                       struct serpiente * );
void EliminaCola( Display *, Pixmap, Window, GC,
                       struct serpiente * );
void BorraSerpiente( Display *, Pixmap, Window, GC,
                       struct serpiente * );
void ActualizaPuntos( Display *, Pixmap, Window, GC,
                       struct serpiente * );
void DibujaComida( Display *, Drawable, Drawable, GC );
void BorraComida( Display *, Drawable, Drawable, GC, int, int );
void GeneraComida( Display *, Drawable, Drawable, GC );

unsigned long ColorPorNombre( Display *, char *);
void RedibujaPantalla( Display *, Drawable, GC, Pixmap,
                       int, int, int, int  );
void DibujaBitmap( Display *, Drawable, GC, Pixmap, int, int );
void DibujaBloque( Display *, Drawable, Drawable, GC, int, int, char );
